
require "TSerial"
require "complex"
require 'sphere'
require 'colorTab'
require 'slider'
require "utility"

function love.load()
 
  if arg[#arg] == "-debug" then require("mobdebug").start() end
  gr = love.graphics
  im = love.image
  tm = love.timer
  
  
  
  doColorize = false
  
  sp1 = Freq/100  
  sp2 = StartColor/100
  sp3 = 1 * (80/360)
  sp4 = 1
  sp5 = 1 
  
  drawHelpFlag  = true
  
  winFlag = false
  
  KeyMod = 0 KNum = 0
  KeyPressed = 0
  KStr="" KStrTab={}   
--keymodify = 0



  Mxc=0 Myc = 0 Mrd = 1
  pMxc = 0 pMyc=0
  MklikX=0 MklikY=0  
  --pMklikX=0 pMklikY=0  
  

  ----------------- tiles ------------
  TXn = 1  TYn = 1
  MxcT = Mxc  
  MycT = Myc
  MxcTo = Mxc  
  MycTo = Myc
  ----------------- tiles ------------



  zoomFactor = 10 -- 10x
  zoomRadius = 20  
  
  local r,g,b,a  
  r=1 g=250 b=1  a=255
  draw_sphere (20, 4,0,r,g,b,a)
  imageSG = gr.newImage(imageSD)
  
  
  Par={}
  if love.filesystem.exists("par.txt")==false then
    Par[1] = 1 -- 
    Par[2] = 2 -- 
    local str1 = TSerial.pack(Par)
    love.filesystem.write("par.txt",str1)
  else
    local str1 = love.filesystem.read("par.txt")
    Par=TSerial.unpack(str1)
  end
  
  MbGlobals()    
  
  buildColorsTab()
    
  Clean = true
  
  
  
  
  imageDChar = im.newImageData("charset.png")
  --canvas1 = gr.newCanvas(100,100) -- prepare an off screen canvas
  
  
  imageDTest = im.newImageData(100,100)
  imageDTest:mapPixel(fill)
  imageGTest = gr.newImage(imageDTest,0,0,0,0.1,0.1)
  
  
  toggleMe = false
  imageMeD=im.newImageData('me.png')
  imageMeG=gr.newImage(imageMeD)
  
  
  setButton(16,1,20,4,1,'full')    
  
  Msx1=0 Msy1=0  Msx2=0 Msy2=0 MShow=true
  
  lastDrawTime = 0
  drawTime = 0
  
--  fontg1 = love.graphics.newImageFont("disegno.png","0123456789!")
--  fontg = love.graphics.newImageFont("imagefont2.png",
--    " abcdefghijklmnopqrstuvwxyz" ..
--    "ABCDEFGHIJKLMNOPQRSTUVWXYZ0" ..
--    "123456789.,!?-+/():;%&`'*#=[]\"")
--  font13 = love.graphics.newFont("Courier New.ttf",13)
--  font14 = love.graphics.newFont("Courier New Bold.ttf",14)
--  font16 = love.graphics.newFont("Courier New Bold.ttf",16)
--  font18 = love.graphics.newFont("consola.ttf",18)
  
  
  sw,sh,fs,vsync,fsaa = gr.getMode()
  -- vsync = false  fsaa = 1
  --sw = 1000 sh = 800
  --gr.setMode(sw,sh,fs,vsync,fsaa)


  


  p1MklikX=sw/2-2 p1MklikY=sh/2-2  
  p2MklikX=sw/2+2 p2MklikY=sh/2+2  



  t1 = 0 t2 = 0
  x1 = 0
  x2 = 0 x2v = 0  rdy = "idle"
  x3=0 x4=0 x5=0
  tt1 = 0
  tt2 = 0
  
  vnn=0 ct=0 ni=0
  vnn2 = 0
  
  tr = love.thread.newThread('threadN1','thread1.lua')
  tr:start()
  
  tr2 = love.thread.newThread('threadN2','Thread2.lua')
  tr2:start()
    
  keepTAP(KFirst)
  
  
  
  
  
  -------------------------------------
  -- mandelbrot related images 
  -- (data:imgaD2  graphics:imageG2)
  -------------------------------------
  imageD2 = im.newImageData(100,100)      newPositionImageD2()
  imageD2base = im.newImageData(100,100)  
  imageG2base = gr.newImage(imageD2base) 
  
  imageD2:mapPixel(fillRed)
  imageG2 = gr.newImage(imageD2) 
  C2TabImageD = im.newImageData(sw*0.8,100)
  imageTabG = gr.newImage(C2TabImageD)
  -------------------------------------
  
  imageD = im.newImageData(100,100)
  imageD:mapPixel(mapPixel_fillGreen)
  imageG = gr.newImage(imageD)
  
  
  -------------------------------------
  -- test image merging
  -------------------------------------
  imageDM=im.newImageData(imageD2:getWidth(),imageD2:getHeight())
  imageGM = gr.newImage(imageDM)
  
  imageDName=im.newImageData(10,10)
  imageGName= gr.newImage(imageDName)  
  -------------------------------------
  
  
  
  d3r = 0 -- used for rotation
  SpeedInc = 0.01
  
  
  rdy = "idle..."
  --tr:set('c3',true)  -- build imageD inthread 
  --tr:set('c2',true)  -- keep imageD reference in thread
  
  
  love.keyboard.setKeyRepeat(0.3,0.05)
  
  
  imageSG = gr.newImage(imageSD)  
  

  
  doMandel()
  
end

function love.update(dt)
  
  
  if doColorize then Colorize() end
  
  x3 = x3 + dt
  x5 = x5 + 1
  
  t1 = t1 + dt
  if t1 >= 1 then
    t1 = t1 - 1
    x2v = x2
    x2 = 0
    collectgarbage()
  end
  
  
  t2 = t2 + dt
  if t2 >= 0.1 then
    t2 = t2 - 0.1
    --g4()
    --g3()
  end
  
  
  if tr:peek('c2Data') ~= nil then
    imageD = tr:get('c2Data')
    if imageD then
      imageG = gr.newImage(imageD)
    end
  end
  
  if tr:get('c3Done') then 
    tr:set('c2',true) -- request imageD
    rdy = "done" 
  end
  
  --tr:set('c1',true) -- we want 'c1' every update
  
  local x
  x = tr:get("r1")
  if x ~= nil then
    x1 = x
  end
  
  
  if tr:peek('rt') then
   tt = tr:get('rt')
   --print(tt)
   str = TSerial.unpack(tt)
   --print(str)
  end
  
  
  if tr2:get('done2') then
    imageD2 = tr2:get('id2r')
    imageG2 = gr.newImage(imageD2) newPositionImageD2()
    local str= tr2:get('C2tabStr')
    C2tab = TSerial.unpack(str)
    C2TabImageD = buildTabImage(C2tab)
    imageTabG = gr.newImage(C2TabImageD)
  end
  
  if tr2:peek('id2rK')  then
    imageD2 = tr2:get('id2rK')
    imageG2 = gr.newImage(imageD2) newPositionImageD2()
  end
  if tr2:peek('id2rK1')  then
    imageD2base = tr2:get('id2rK1')
    imageG2base = gr.newImage(imageD2base) 
  end
  
end

angolo = 0
angoloInc = 0 --0.01
skx = 0
sky = 0

showD2 = true


--local CanChange = true
--checkSet(6, CanChange)

function love.draw()
    
  showLive()
  
  if toggleMe then
    gr.draw(imageMeG,0,0,0,0.3,0.3)
  end
  
  angolo  = angolo + angoloInc
  --if showD2 then gr.draw(imageG2,Mbx1+Mbw/2,Mby1+Mbh/2,angolo,1,1,Mbw/2+skx,Mbh/2+sky) end -- mandelbrot image end
  --gr.draw(imageG2base,Mbx1+Mbw/2,Mby1+Mbh/2,angolo,1,1,Mbw/2+skx,Mbh/2+sky) -- mandelbrot image end
  gr.draw(imageG2,Mbx1+Mbw/2,Mby1+Mbh/2,angolo,1,1,Mbw/2+skx,Mbh/2+sky) -- mandelbrot image end
  
  
  --gr.draw(imageGM,Mbx1+Mbw/2,Mby1+Mbh/2,angolo,1,1,Mbw/2+skx,Mbh/2+sky) -- mandelbrot image
  gr.draw(imageGM,Mbx1+Mbw/2,Mby1+Mbh/2,0,1,1,Mbw/2+skx,Mbh/2+sky) -- mandelbrot image

  
  
  ----------------------------------------------
  -- draw color table and escapeNumbers istogram
  ----------------------------------------------
  local xn
  for xn=0,NumColors do
    gr.setPointSize(8) gr.setColor(250,250,250,250) 
    gr.point(xn/NumColors*sw,104)
  end
  local r,g,b,a
  for xn=0,NumColors do
    gr.setPointSize(4)
    r,g,b,a = gettabColor(xn)
    gr.setColor(r,g,b,250)
    --gr.setColor(tabColor[xn][1],tabColor[xn][2],tabColor[xn][3],250)
    gr.point(xn/NumColors*sw , 104)
  end
  gr.setColor(255,255,255,255)
  gr.setPointSize(1)
  gr.draw(imageTabG,0,0) --sh-imageTabG:getHeight())
  ----------------------------------------------
  
  
  --lastDrawTime = drawTime
  --drawTime = tm.getMicroTime()
  
  x2=x2+1
  x4=x4+1
  
  local aa,bb
  aa = sw/2  bb = sh/2
  --gr.draw(imageG,aa,bb,d3r,1,1,imageG:getWidth()/2,imageG:getHeight()/2)
  d3r = d3r + SpeedInc
  
  if not Clean then
  else
  end
  
  
  ---------------------------------------------
  if tr2:peek('nn') then
    vnn = tr2:get('nn')
  end
  if tr2:get('done') then
   ct = tr2:get('rest')
   ni = tr2:get('resv')
  end
  ----------------------------------------------
  
  
  ---------------------------------------------
  if tr2:peek('nn2') then
    vnn2 = tr2:get('nn2')
  end
  
  
  
  
  -----------------------------
  -- mandelbrot data
  -----------------------------
  
  keepMbPositions()
  
    local xa,ya
    
    -- external markers
    xa = Mbx1 + Mbw * (MbXratio+1)/2  ya = Mby1 + Mbh * (MbYratio+1)/2
    
    gr.line(xa,Mby1,xa,Mby1-10)  gr.line(xa,Mby2,xa,Mby2+10)
    gr.line(Mbx1,ya,Mbx1-10,ya)  gr.line(Mbx2,ya,Mbx2+10,ya)
    
    
    
    
    
    -- little dot
    xa = MklikX ya = MklikY
    gr.line(xa-3,ya,xa+3,ya)  gr.line(xa,ya-3,xa,ya+3) -- small cross 





    if MShow then
      
      --bm1
        if zoomRadius > 4 then
          gr.circle("line", MklikX,MklikY,zoomRadius)
        end
      ---------------- mouse cross
      local mx,my
      mx,my = love.mouse.getPosition()
      if mx>Mbx1 and mx < Mbx2  and my>Mby1 and my<Mby2 then
        gr.line(mx,Mby1,mx,Mby2)
        gr.line(Mbx1,my,Mbx2,my)
        --gr.print("X",0,0)
      end
      
  end
  

    
  
  gr.draw(imageSG,0,200) -- ball test image
  
  --drawTime = tm.getMicroTime() - drawTime
  
  gr.print("h: toggle help",0,108)
  if drawHelpFlag then drawHelp(0,132,16)   end
  
  
  --gr.draw(imageGTest)
  --gr.draw(imageGName,0,0) 
  --gr.print(status,0,0)
    
    controls()

  
end




function drawHelp(x,y,k)
  local p,i,v,str

  p = 1
  gr.print( "tileXY   "..TXn.." "..TYn,1/4*sw,sh-p*k)p=p+1
  
  str = "c: "
  for i=1,#KStrTab do
    local s = KStrTab[i]
    if s~=nil and s~= ""  then str  = str..s.." " end
  end
  gr.print(str,1/4*sw,sh-p*k)p=p+1


  p = 1
  gr.print( Mxc.." (xc )",0,sh-p*k)p=p+1
  gr.print(pMxc.." (xcp)",0,sh-p*k)p=p+1
  gr.print(MxcT.." (xct )",0,sh-p*k)p=p+1
  gr.print(MxcTo.." (xcto)",0,sh-p*k)p=p+1
  gr.print( "",0,sh-p*k)p=p+1
  gr.print( Myc.." (yc )",0,sh-p*k)p=p+1
  gr.print(pMyc.." (ycp)",0,sh-p*k)p=p+1
  gr.print(MycT.." (yct )",0,sh-p*k)p=p+1
  gr.print(MycTo.." (ycto )",0,sh-p*k)p=p+1
  gr.print("",0,sh-p*k)p=p+1
  gr.print("rd:"..Mrd,0,sh-p*k)p=p+1
  gr.print("",0,sh-p*k)p=p+1
  gr.print("mxr:"..MbXratio,0,sh-p*k)p=p+1
  gr.print("myr:"..MbYratio,0,sh-p*k)p=p+1
  gr.print("n: "..vnn2,0,sh-p*k)p=p+1
  -----------------------------


--gr.setFont(font14)
gr.print("alt f4: exit",x,y+p) p=p+k  
gr.print("k:print image TAPs(xc,yc,rd)",x,y+p) p=p+k

--gr.print("kp1..6: Size 1..6 x100",x,y+p) p=p+k

gr.print("------------",x,y+p) p=p+k

gr.print("klik:prepare new center",x,y+p) p=p+k
gr.print("i:prepare zoom in",x,y+p) p=p+k
gr.print("o:prepare zoom out",x,y+p) p=p+k
gr.print("c:keep new center",x,y+p) p=p+k
gr.print("q:set zoom radius",x,y+p) p=p+k
gr.print("w:draw window",x,y+p) p=p+k
gr.print("m:draw mandelbrot",x,y+p) p=p+k
gr.print("x:stop draw",x,y+p) p=p+k
gr.print("s:save image",x,y+p) p=p+k
gr.print("------------",x,y+p) p=p+k

local kx = sw - 200
gr.print("--(n:digit keys) (cr:key return) --",kx+x,y+p) p=p+k
gr.print("Esc t n cr: Mandelbrot TAP",kx+x,y+p) p=p+k
gr.print("Esc s n cr: image Size",kx+x,y+p) p=p+k
gr.print("Esc z n cr: zoom factor",kx+x,y+p) p=p+k
gr.print("Esc i n cr: MAXITER    ",kx+x,y+p) p=p+k
gr.print("up,dw,left,right:move image",kx+x,y+p) p=p+k
gr.print("pgup,pgdw: rotation",kx+x,y+p) p=p+k
gr.print("home:image at home",kx+x,y+p) p=p+k
gr.print("Esc 0: exit",kx+x,y+p) p=p+k
gr.print("Esc m: who am i?",kx+x,y+p) p=p+k
gr.print("------------",kx+x,y+p) p=p+k
gr.print("TAPindex:"..TAPindex ,kx+x,y+p) p=p+k
gr.print("MAXITER:"..MAXITER ,kx+x,y+p) p=p+k
gr.print("------------",kx+x,y+p) p=p+k


--local k=16 
local n=1
gr.print("image Size:"..imageD2:getWidth().."x"..imageD2:getHeight().."  sk y,x:"..sky..","..skx.. "  angle:"..angolo,sw/2,sh-k*n ) n=n+1
gr.print("zoomFactor:"..zoomFactor,sw/2,sh-k*n ) n=n+1


local r,g,b,a
r,g,b,a = gr.getColor()
if KeyMod ~= 0 then
  gr.setColor(255,255,0,255)
end
gr.print("KeyMod:"..KeyMod.."  KNum:"..KNum,sw/2,sh-k*n ) n=n+1
gr.print("key:"..KeyPressed,sw/2,sh-k*n ) n=n+1
gr.setColor(r,g,b,a)


--	local bg = 'CIPPO' --OBEY'
--  font = love.graphics.newFont(100)
--  gr.setFont(font)
--  gr.setColor(255,255,0,125)
--	love.graphics.print(bg, 0, 240, math.pi / 4, 1, 1)
--  font = love.graphics.newFont(12)
--  gr.setFont(font)

end

















--==============================================================================
function getKTs(n)
  if KStrTab[n]==nil then return ""  else  return KStrTab[n] end
end
function getKTn(n)
  local v = tonumber(KStrTab[n])
  if v==nil then return 0 else return v end
end
function executeKstr()

  for i,v in ipairs(KStrTab) do
    print(i.." "..KStrTab[i])
  end

  local v1,v2, sc 
  sc = getKTs(1) 
  if sc=="" then return end
  if  sc=='tile' then
    TXn = getKTn(2)    
    TYn = getKTn(3)
    MxcT = MxcTo + 2*Mrd * TXn    pMxc = MxcT
    MycT = MycTo + 2*Mrd * TYn    pMyc = MycT
  end  
end

function KeyModFunct(key)
  local v
  
  if KeyMod == 0 then     return   end
  
  if KeyMod == 100 then -- lalt check exit
    if key == 'f4' then  love.event.quit()  end  
  end
 
  if key == 'escape' then  KeyMod = 0 KNum = 0  Kstr = 0 return  end
  
  if KeyMod == 1 then  -- from escape x  : enter selection
    if key == 'c' then KeyMod = 200 KNum = 0 KStr="" KStrTab={} return end -- size selector
    if key == 's' then KeyMod = 2 KNum = 0 return end -- size selector
    if key == 't' then KeyMod = 3 KNum = 0 return end -- tap selector
    if key == 'z' then KeyMod = 4 KNum = 0 return end -- zoomFactor selector
    if key == 'i' then KeyMod = 5 KNum = 0 return end -- MAXITER
    if key == '0' then  love.event.quit()  KeyMod = 0 end  -- who am i?
    if key == 'm' then  toggleMe = not toggleMe  KeyMod = 0 end  -- who am i?
  end
  
  
  ----------------------------------- KeyMod 200: build comand string
  if KeyMod == 200 then  
    
    if key == 'return'then  
      --print(KStr)
      table.insert(KStrTab,KStr)
      --print('execute Kt')
      executeKstr()
      --KStrTab={}
      --KStr=''
      --print('done')
      KeyMod=0
    end
    
    if key == ' ' or key == ',' then  
      --print(KStr)
      if KStr ~= "" then  table.insert(KStrTab,KStr) end
      KStr = ''
    else
      KStr = KStr..key return 
    end
    
  end
  ---------------------------------------------------------------
    
    
    
  if KeyMod == 2 then  
    if key >= '0' and key <= '9' then v = tonumber(key) KNum=KNum*10+v  end
    if key == 'return' then 
      tr2:set('size', KNum)
      KeyMod = 0
    end
  end
  
  if KeyMod == 3 then  
    if key >= '0' and key <= '9' then v = tonumber(key) KNum=KNum*10+v  end
    if key == 'return' then 
      if TAP[KNum]~=nil  then  keepTAP(KNum)   end
      KeyMod = 0
    end
  end

  if KeyMod == 4 then  
    if key >= '0' and key <= '9' then v = tonumber(key) KNum=KNum*10 + v*0.1  end
    if key == 'return' then 
      if(KNum <  0.1) then KNum =  0.1 end  -- min 1x
      if(KNum > 100) then KNum = 100 end  -- max 50x
      zoomFactor = KNum 
      KeyMod = 0
    end
  end
  
  if KeyMod == 5 then  
    if key >= '0' and key <= '9' then v = tonumber(key) KNum=KNum*10 + v * 1  end
    if key == 'return' then 
      if(KNum <  100) then KNum =  100 end  
      if(KNum > 8000) then KNum = 8000 end  
      tr2:set('maxiter',KNum )
      MAXITER = KNum
      KeyMod = 0
    end
  end
  
  
end

--==============================================================================

function love.keypressed(key)
  
  KeyPressed = key
  
  if KeyMod ~= 0  then
    KeyModFunct(key)
    return
  end
  
  if key == 'escape' then
      KeyMod = 1
      return
  end
  
  if key == 'lalt' then
      KeyMod = 100
      return
  end
  
  
  if key == 'home' then
    angolo=0 angoloInc = 0 skx=0 sky=0
  end
  
  if key == 'pageup' then angoloInc = angoloInc+0.0001 end
  if key == 'pagedown' then angoloInc = angoloInc-0.0001 end
  
--  if key == 'kp+' then
--    angoloInc = angoloInc+0.0001
--  end
--  if key == 'kp-' then
--    angoloInc = angoloInc-0.0001
--  end
  
  
  if key == 'up' then
    sky=sky-10
  end
  if key == 'down' then
    sky=sky+10
  end
  if key == 'left' then
    skx=skx-10
  end
  if key == 'right' then
    skx=skx+10
  end
  
  
  if key == 'f2'  then
    for i=0,100 do
      keepTAP(i)
    end
  end
  
  
--  if key >= '1' and key <='9' then
--    local n = tonumber(key)
--    keepTAP(n)
--  end

  if key == 'k' then
    local str1=""
    
    showBox()
    
    print("saving TAP data...")
    local str2 = "TAP_"..os.time()..".txt"
    love.filesystem.write(str2,str1)
    print("saved.")
    
  end

--  if key == 'kp1' then  tr2:set('size1',true)  end  
--  if key == 'kp2' then  tr2:set('size2',true)  end  
--  if key == 'kp3' then  tr2:set('size3',true)  end  
--  if key == 'kp4' then  tr2:set('size4',true)  end  
--  if key == 'kp5' then  tr2:set('size5',true)  end  
--  if key == 'kp6' then  tr2:set('size6',true)  end  
--  if key == 'kp7' then  tr2:set('size7',true)  end  
--  if key == 'kp8' then  tr2:set('size8',true)  end  
--  if key == 'kp9' then  tr2:set('size9',true)  end  
    
  
  if key == 'x'then
    tr2:set('stop',true)
  end
  
  if key == 's' then
    --tr2:set('saveData',true)
    saveImage()
  end
  
  if key == '.'then  -- show cursor lines
    MShow = not MShow
  end
  
--  if key == 'b' then -- draw ball
--    local r,g,b,a  
--    r=200 g=200 b=50 a=255
--    draw_sphere (20, 4,0,r,g,b,a)
--    imageSG = gr.newImage(imageSD)
--  end
  
  if key == 'i' then -- zoom in
    
    --if dxm < (4e-14  * XYRatio) or dym < 4e-14 then return end
--    if dxm < (4e-14  * 1) or dym < 4e-14 then return end
--    if dxm > 2 or dym > 2 then return  end
--    dxm = dxm * 0.1
--    dym = dym * 0.1
--    mx1 = mxc - dxm/2  mx2 = mxc + dxm/2
--    my1 = myc - dym/2  my2 = myc + dym/2
    
    
    Mrd = Mrd / zoomFactor
    if Mrd < 4e-14 then Mrd = 4e-14 end
    
    
--    Mxc = pMxc
--    Myc = pMyc
--    
--  MbXratio = 0
--  MbYratio = 0
--  MklikX = Mbx1 + Mbw * (MbXratio+1)/2
--  MklikY = Mby1 + Mbh * (MbYratio+1)/2
--    
    
    
  end
  
  if key == 'o' then --zoo out
    
    --if dxm < (4e-14  * XYRatio) or dym < 4e-14 then return end
--    if dxm < (4e-14  * 1) or dym < 4e-14 then return end
--    if dxm > 2 or dym > 2 then return  end
--    
--    dxm = dxm * 10
--    dym = dym * 10
--    mx1 = mxc - dxm/2  mx2 = mxc + dxm/2
--    my1 = myc - dym/2  my2 = myc + dym/2
    
    Mrd = Mrd * zoomFactor
    if Mrd > 2 then Mrd = 2 end
    
--    Mxc = pMxc
--    Myc = pMyc
--    
--    MbXratio = 0
--    MbYratio = 0
--    MklikX = Mbx1 + Mbw * (MbXratio+1)/2
--    MklikY = Mby1 + Mbh * (MbYratio+1)/2
    
  end
  
  if key == 'c' then -- center image
--    mx1 = mxc - dxm/2  mx2 = mxc + dxm/2
--    my1 = myc - dym/2  my2 = myc + dym/2
    
--    Mxc = Mxc-Mrd +  Mrd *  MbXratio  
--    Myc = Myc-Mrd +  Mrd *  MbYratio
    
--  pMxc = Mxc-Mrd  + Mrd *  MbXratio
--  pMyc = Myc-Mrd  + Mrd *  MbYratio
    
    
--    Mxc = pMxc
--    Myc = pMyc
--    
--    MbXratio = 0
--    MbYratio = 0
--    MklikX = Mbx1 + Mbw * (MbXratio+1)/2
--    MklikY = Mby1 + Mbh * (MbYratio+1)/2
    
  end
  
  if key == 'm' then
    
    Mxc = pMxc
    Myc = pMyc
    
    MbXratio = 0
    MbYratio = 0
    MklikX = Mbx1 + Mbw * (MbXratio+1)/2
    MklikY = Mby1 + Mbh * (MbYratio+1)/2
    
    --showBox()
    doMandel()
  end
  
  
  
  if key == 'w' then
    
    local zoom,Mbmin
    
    Mbmin = math.min(Mbw,Mbh)
    zoom = Mbmin / (2*zoomRadius)
    
    Mrd = Mrd / zoom
    
    if Mrd < 4e-14 then Mrd = 4e-14 end
    Mxc = pMxc
    Myc = pMyc
    
--    MbXratio = 0
--    MbYratio = 0
--    MklikX = Mbx1 + Mbw * (MbXratio+1)/2
--    MklikY = Mby1 + Mbh * (MbYratio+1)/2
    
    MbXratio = 0
    MbYratio = 0
    MklikX = Mbx1 + Mbw * (MbXratio+1)/2
    MklikY = Mby1 + Mbh * (MbYratio+1)/2
    
    
    doMandel()
    
  end
  
  
  
  
  
--  if key == 'q'then  -- window zoom (first  window coordinates)
--    
--    p2MklikX = p1MklikX  p2MklikY = p1MklikY
--    p1MklikX = MklikX    p1MklikY = MklikY
--    
--    if (p2MklikX == nil) or   (p2MklikY ==nil) then return end
--      
--    winFlag = true
--  end




--  if key == 'q'then  -- window zoom (one window coordinates)
--    p1MklikX = MklikX  p1MklikY = MklikY
--  end
  
--  if key == 's'then  -- window zoom (other window coordinates)
--    p2MklikX = MklikX    p2MklikY = MklikY
--  end
--  
--  if key == 'w' then  -- window zoom (second window coordinates)
--   
--    local xa,ya,xw,yh, xc1,yc1,  xc2,yc2, xd,yd, xdr, ydr, Mbmin
--    
--    if (p1MklikX == p2MklikX) then  p2MklikX = p1MklikX + 4  end
--    
--    if (p1MklikY == p2MklikY) then  p2MklikY = p1MklikY + 4  end
--
--    xa = math.min(p1MklikX,p2MklikX)
--    ya = math.min(p1MklikY,p2MklikY)
--    xw=math.abs(p1MklikX - p2MklikX) 
--    yh=math.abs(p1MklikY - p2MklikY)
--    
--    
--    Mbmin=math.min(Mbw,Mbh)
--    
--    --    ----- sposta centro ( distanze relative al raggio attuale )
--    --    
--    --    -- centro della box
--    --    xc1 = Mbw/2  yc1 = Mbh/2
--    --    
--    --    --- centro della zoom window 
--    --    xc2 = xa + xw/2   yc2 = ya + yh/2
--    --    
--    --    -- distanze dal centro
--    --    xd = xc2-xc1   yd = yc2-yc1
--    --    
--    --    -- rapporti finestra
--    --    xdr = xd/Mbmin  ydr = yd/Mbmin
--    --    
--    --    Mxc = Mxc + Mrd * xdr
--    --    Myc = Myc + Mrd * ydr
--    
--    ----- cambia raggio 
--    Mrd = Mrd * xw/Mbmin
--    
--    -----------------------------------------------
--    
--    doMandel()
--    
--  end
--
  
  if key=='h' then
    drawHelpFlag = not drawHelpFlag
  end
  
  if key == 'z' then
    skx=0 sky=0 angolo=0 angoloInc=0
  end
  
  if key=='r' then
    imageD2base=im.newImageData('out.png')
    imageD2=im.newImageData(imageD2base:getWidth(),imageD2base:getHeight())
    imageD2:paste(imageD2base,0,0 , 0,0, imageD2base:getWidth(),imageD2base:getHeight())
    imageG2=gr.newImage(imageD2)
    newPositionImageD2()
  end
  
  
  if key=='q' then
    
    inside = keepMbPositions()
    
    if inside then

      local MklikXL = Mbx1 + Mbw * (MbXratio+1)/2
      local MklikYL = Mby1 + Mbh * (MbYratio+1)/2
      
      local dx,dy,dr
      dx = MklikXL - MklikX
      dy = MklikYL - MklikY
      zoomRadius = math.sqrt(dx*dx+dy*dy)
      
    end
    
  end  
    
  
  
  if key=='a' then
    --showD2 = not showD2
    --imageDM = imageD2
    local x,y
    --x = imageDM:getWidth()* MbXratio
    --y = imageDM:getHeight()* MbYratio
    --merge (imageDM , imageD2,x,y,  imageSD,0,0,40,40 )
    
    Xi2 = imageD2:getWidth()* MbXratio
    Yi2 = imageD2:getHeight()* MbXratio
    draw_sphere (20, 4,0,  250,250,10,255)
    imageG2 = gr.newImage(imageD2)  
    
  end
  if key=='v' then
    imageDM = imageD2
  end
  

  if key=='t' then -- test
    local str1
    --str1 = "X1="..mx1.."  X2="..mx2.."  Y1="..my1.."  Y2="..my2
    str1 = "{"..Mxc..","..Myc..","..Mrd.." },"
    --printOnImageDName(str1)
    buildString(str1) 
  end
  
--[[
	local bg = 'CIPPO' --OBEY'
  font = love.graphics.newFont(100)
  gr.setFont(font)
  gr.setColor(255,255,0,125)
	love.graphics.print(bg, 0, 240, math.pi / 4, 1, 1)
  font = love.graphics.newFont(12)
  gr.setFont(font)
]]  
  

end
          
function  love.mousepressed()
  
  inside = keepMbPositions()
  
  if love.mouse.isDown("l") then
    
    
    
    if inside then
--      dxm = math.abs(mx1-mx2)
--      dym = math.abs(my1-my2)
--      mxc = mx1 + dxm * MbXratio
--      myc = my1 + dym * MbYratio    
      
      
    -- to draw little cross
    MklikX = Mbx1 + Mbw * (MbXratio+1)/2
    MklikY = Mby1 + Mbh * (MbYratio+1)/2
      
    pMxc = Mxc + Mrd * MbXratio
    pMyc = Myc + Mrd * MbYratio   
      
    end
  end
  
end


function MbGlobals()  
  ------------------------------------------------------  
  --   some  used globals  for mandelbrot
  ------------------------------------------------------  
  z = complex.new(0,0)
  
  c = complex.new(0.001643721,0.82246763)
  
  nc = 1
  ncf = 0
  dist = 0
  
--  mx1 = -2    mx2 = 0.5
--  my1 = -1.25 my2 = 1.25
  keepTAP(1)
  
--  dxm = math.abs(mx1-mx2)/2
--  dym = math.abs(my1-my2)/2
--  mxc = mx1 + dxm/2
--  myc = my1 + dym/2
 
 
  Nx1=0 Nx2=0 Ny1=0 Ny2=0

  k11 = 1e-7
  km9 = 1e-11
  
  --doMandel()
end



--TAP={ -- insert here TAP(x1,x2,y1,y2)
  
  --  {-2,0.5,-1.25,1.25},  
  --    --{0.41744864804471,0.41744865429471,-0.2113001475,-0.21130014125},
  --    --{0.41744864356203,0.41744870606203,-0.21130015625,-0.21130009375},
  --    {-1.36841527 , -1.36841477 , -0.01166799 , -0.01166749},
  --    {0.4171375,0.4177625,-0.211625,-0.211	},
  --    {-1.253574768227,-1.2535747681879,-0.022708294966489,-0.022708294927427	},
  --    {-1.2535747682661,-1.2535747681684,-0.022708294997739,-0.022708294900084	},
  --    {0.43517109375004,0.43526875000004,0.34146367187494,0.34156132812494	},
  --    {-1.2535747683052,-1.2535747681097,-0.022708295044613,-0.022708294849303	},
  --    {0.44323762154096,0.44323762154098,-0.23175904688112,-0.23175904688114	},
  --
  --
  --    --{0.41746111045966,0.41746736045966,-0.211264453125,-0.211258203125},          --9
  --    {0.41744550364583,0.4174486078125,-0.21130279506944,-0.21129969090278},  --9
  --
  --
  --    {0.44323762154097,0.44323762154097,-0.23175904688113,-0.23175904688113	},
  --    {0.44323762716147,0.44323763340648,-0.23175905300123,-0.23175904675623	},
  --    {0.44323762833241,0.44323763223554,-0.23175905183029,-0.23175904792717	},
  --    {0.44323762983512,0.44323763003027,-0.2317590497226,-0.23175904952745	},
  --    {0.44323762871301,0.44323763115238,-0.23175905084471,-0.23175904840534	},
  --    --[[
  --
  --    http://www.cygnus-software.com/gallery/bigimages/jewel_box.htm
  --    center -1.367,964,148,94 +0.008,122,488,10 
  --    ]]
  --    --{-1.36796414894-k11, -1.36796414894+k11, 0.00812248810-k11, 0.00812248810+k11},
  --    {-1.36796419494,-1.36796409494,0.0081224401,0.0081225401	},
  --    --{-0.56688227124355-km9,-0.56688227124355+km9,-0.56439613649795-km9,-0.56439613649795+km9},
  --    {0.30110705636428,0.30110705636432,-0.020262469984143,-0.020262469984104	},
  --    {-0.038449986831694,-0.038449986277548,0.98550807370098,0.98550807432136	},
  --    {-0.038449986438029,-0.038449986437475,0.98550807378129,0.98550807378185},
  --    {-0.87475646435395,-0.87475646359771,-0.25345079828772,-0.25345079753148},
  --    {-1.3684150211635,-1.3684150206635,-0.01166775063,-0.01166775013},
  --    {-0.22586363591323 , -0.22586356540245, 0.70048317745816, 0.70048324796895 },
  --
--}


TAP={
  {-0.75,0,1.25 },
  
  {-0.698184831535,0.37837090017418,4e-014 }, --2
  
  {-1.36841502,-0.01166774,2.4999999999938e-007 }, --3
  {0.41745,-0.2113125,0.00031249999999999 }, --4
  {-1.2535747682075,-0.022708294946958,1.9531000081119e-011 },
  {-1.2535747682173,-0.022708294948912,4.8827499335435e-011 },
  {0.43521992187504,0.34151249999994,4.8828125000011e-005 },
  {-1.2535747682075,-0.022708294946958,9.7655000405594e-011 },
  {0.44323762154097,-0.23175904688111,9.9920072216264e-015 },
  {0.41744705572916,-0.21130124298611,1.5520833299976e-006 },
  {0.44323762154097,-0.23175904688113,9.9920072216264e-015 },
  
  {0.44323762992489,-0.23175904955087,3.1225000085566e-009 }, --12
  
  {0.44323763028398,-0.23175904987873,1.9515599969377e-009 },
  {0.4432376299327,-0.23175904962503,9.75750036325e-011 },
  {0.4432376299327,-0.23175904962503,1.2196849918933e-009 },
  {-1.36796414494,0.0081224901,5.000000000057e-008 },
  {0.3011070563643,-0.020262469984124,1.9500026593455e-014 }, --17
  {-0.038449986554621,0.98550807401117,2.7707299996016e-010 },
  {-0.038449986437752,0.98550807378157,2.7700064464398e-013 },
  {-0.87475646397583,-0.2534507979096,3.7812000752702e-010 },
  {-1.3684150209135,-0.01166775038,2.4999999986841e-010 },
  {-0.22586360065784,0.70048321271355,3.5255389996269e-008 },
  
  {0.33141573032371,-0.046925944228621,5.4425743932029e-008 }, --23
  
  {-1.246613224004,0.088440981751005,2.7286099941179e-006 }, --24  
 
 
 -----julia
 --http://www.jcu.edu/math/vignettes/Julia.htm
  {0.687,0.312,2}, -- 25
  {0.03515, -0.07467,2}, -- 26
  --{ 0.03515, -0.07467   ,1}, -- 27
  
  {-0.74543, -0.11301,2}, -- 27
  
  { 0.233, -0.53780,  2}, -- 28
  
  {-0.74173, 0.15518,2}, -- 29
  {-0.55947, 0.64196,2}, --30
  {-0.74434, -0.10772,2}, --31
  
  {0.41453 , 0.34364,2}, --32
  
  
   {-0.67319 , 0.34442,2}, --33
   
   
{-0.74889170208588 ,-0.088936043163655,7.8018343025081e-005   }, --34

{-0.74805356527084 ,-0.089741494867963 ,0.0012864989183084 }, --35
{-0.78780312183165 ,-0.16265077789187 ,0.00028274701501284 }, --36
{-1.2554477493817, -0.026173950049288, 1e-3}, -- 37
{-1.2533550564393, -0.020633650049288, 2e-5 },--38
{-1.2526756252047, -0.022717023376883, 4e-6}, --39

{-1.2500239031242,-0.0020758853112036,2.05e-006 }, --40
{-1.2609717156529,-0.037267058145146,0.00084761542448784 }, --41
{-0.03844998655462,0.98495807401117,1e-10}, --42
{0.10834282195156,-0.62361972370754,3.4878368263329e-011 }, --43

{-0.75758826375563,-0.073275651825009,9.6634370344747e-005 }, --44
{-0.75758874692748,-0.073278067684268,9.578996202771e-005 }, --45

{-0.75756093774647,-0.073263731939222,7.0049991530792e-007 },--46

{-0.20266263960404, -0.67641801286482,0.00018614272030197 }, --47

{-0.01883435735735,-0.70963324661882,0.00016188800611275}, --48

{-1.293076206492,0.074768661787141,4e-005}, --49

{-0.78780877677195,-0.16264323797147,0.00026988807780862 },--50
-----------------------------------  
}


KFirst = 50
TAPindex = KFirst


function keepTAP(n)
  
  
--  if TAP[n]==nil then -- if exist some old mode (x1,x2,y1,y2) use it
    if TAP[n]~=nil then  -- if exist center radius, use this
      
      TAPindex = n

      Mxc = TAP[n][1]
      Myc = TAP[n][2]
      Mrd = TAP[n][3]
      pMxc = Mxc
      pMyc = Myc
      
    MxcTo = Mxc  -- set also orign of tiles
    MycTo = Myc      
      
      showBoxC()
      
      return 
    end
  
--  if TAP[n]==nil then return end
--  
--  TAPindex = n
--
--  --local Amx1,Amx2,Amy1,Amy2,Adxm,Adym,Amxc,Amyc
--  local Adxm,Adym,Amxc,Amyc
--  
--  Amx1=TAP[n][1] Amx2=TAP[n][2] Amy1=TAP[n][3] Amy2=TAP[n][4]
--  if Amx1==Amx2 then Amx1 = Amx1 - 1e-14  Amx2 = Amx2+1e-14 end
--  if Amy1==Amy2 then Amy1 = Amy1 - 1e-14  Amy2 = Amy2+1e-14 end
--  Adxm = math.abs(Amx1-Amx2)/2
--  Adym = math.abs(Amy1-Amy2)/2
--  Amxc = Amx1 + Adxm
--  Amyc = Amy1 + Adym
--  
--  --print(Amx1.." "..Adxm)
--  --print(Amy1.." "..Adym)
--  
--  Mxc = Amxc
--  Myc = Amyc
--  Mrd = math.min(Adxm,Adym)
--  
--  pMxc = Mxc
--  pMyc = Myc
--  
--  showBox()
  
end


function doMandel()
  
--    tr2:set('mx1',mx1)
--    tr2:set('mx2',mx2)
--    tr2:set('my1',my1)
--    tr2:set('my2',my2)
    
    tr2:set('Mxc',Mxc)
    tr2:set('Myc',Myc)
    tr2:set('Mrd',Mrd)
    
    tr2:set('c2',true)
end













MaxValue = 0
Media = 0
function buildTabImage (tab)
  
  --bmrk0
  
  local Items = 1
  
  local imageD,n,i,v,k,x,y,max,min,r,g,b,a,idx
  --print ("build table")
  k = MAXITER
  --n = #table
  imageD = im.newImageData(sw,100+1)
  max = 0 min = 1000000
  for i=0,k do -- cerca il massimo
    if (max < tab[i]) then max = tab[i] idx = i end
    if (min > tab[i]) then min = tab[i] idx = i end
    if (tab[i]>1) then Items=Items+1 Media=Media + tab[i] end
  end
  Media = math.floor(Media/Items)
  MaxValue = max
  print ("max: "..max.." at "..idx)
  
  r=200 g=200 b=200 a = 240
  for i=1,k-1 do
    imageD:setPixel(i/MAXITER*(sw-1),100,255,155,0,a) -- base
    x = i  y = 100*tab[i]/max
    for j=1,y do
      imageD:setPixel(x/MAXITER*(sw-1),100-j,r,g,b,a) -- linea verticale
    end
  end
  return imageD
  
end


Buttons={}

function setButton(k,row,col,w,h,t)
  local x1,y1,w1,h1,r,g,b,a,pw
  x1=row*k y1=col*k w1=w*k h1=h*k
  table.insert(Buttons,{x1,y1,x1+w1,y1+h1,t})
end

C2tab={}  



function newPositionImageD2()
  Mbw = imageD2:getWidth()
  Mbh = imageD2:getHeight()
  Mbx1 = 1/2*sw - Mbw/2
  Mby1 = 1/2*sh - Mbh/2
  Mbx2 = Mbx1 + Mbw  
  Mby2 = Mby1 + Mbh  
  MbXratio = 0
  MbYratio = 0
  keepMbPositions()
end



function keepMbPositions()
  local x,y,xa,ya --,r
  x,y = love.mouse.getPosition()
  
  
  if x>Mbx1 and x<Mbx2 and y>Mby1 and y<Mby2 then
    inside = true
    xa = math.abs(x-Mbx1)
    ya = math.abs(y-Mby1)
    --r = math.min(Mbw,Mbh)
    MbXratio = 2*(xa/Mbw)-1   -- return -1..+1
    MbYratio = 2*(ya/Mbh)-1   -- return -1..+1
  else
    inside = false
  end
  return inside
end



function printOnImageDName(text)
  
--    local f,font,cv1,r,g,b,a
--    
--    f = gr.getFont()      --save current font
--    r,g,b,a = gr.getColor()
--    
--    fx = imageD2:getWidth() fy = 12
--    font = gr.newFont(fy-1)
--    gr.setFont(font) 
--    
--    ---------------
--    cv1 = gr.newCanvas(fx , fy )
--    gr.setCanvas(cv1)
--    
--    gr.setColor(70,90,80,255)
--    gr.rectangle("fill",0,0,fx-1,fy-1)  
--    
--    gr.setColor(255,255,255,255)
--    gr.print(text,0, 0)
--    
--    imageDName = cv1:getImageData() 
--    
--    gr.setCanvas() 
--    gr.setFont(f) 
--    gr.setColor(r,g,b,a)
--    
--    imageGName = gr.newImage(imageDName)
    
end

function saveImage()
   
    local wy
    local time = os.time()
    
    local str1 
    --str1 = "X1="..mx1.."  X2="..mx2.."  Y1="..my1.."  Y2="..my2.." esc:"..MAXITER
    --str1 = "xc="..Mxc.." yc="..Myc.." r="..Mrd.." esc:"..MAXITER
    str1 = Mxc..","..Myc..","..Mrd..","..Mrd.." n:"..MAXITER
    print(str1)
    print("saving TAP data...")
    local str2 = "IMG_"..time.."_TAP.txt"
    love.filesystem.write(str2,str1)
    print("saved.")
    
    --printOnImageDName(str1)
    buildString(str1) 
    
    wy = imageD2:getHeight() - imageDName:getHeight() - 2
    
    imageD2:paste(imageDName, 2,wy)
    imageD2base:paste(imageDName, 2,wy)
    
    local name 
    name = "IMG_"..time..".png"           imageD2:encode(name)  
    name = "IMG_"..time.."_base.png"  imageD2base:encode(name)  

end










--tabSize={
--  --{ 133,  100},
--  { 300,  400},
--  { 200,  200},
--  { 300,  300}, 
--  { 300,  400},
--  { 500,  500},
--  { 600,  100},
--  { 800,  600},
--  {1000, 1000},
--  {1200, 1000}
--}
--SizeX=10 SizeY=10
--function setSize(n)
--  if tabSize[n]== nil then
--    SizeX=tabSize[1][1]    SizeY=tabSize[1][2]
--  else      
--    SizeX=tabSize[n][1]    SizeY=tabSize[n][2]
--  end
--  --imageD = im.newImageData(SizeX,SizeY)
--  --imageDBase = im.newImageData(SizeX,SizeY)
--  --imageD:mapPixel(fillGreen)
--  --tr:set('id2rK',imageD) -- pass reference
--  --tr:set('id2rK1',imageDBase)
--end




function showBox()
    -- let's for old mode
    --str1 = "{"..Amx1..","..Amx2..","..Amy1..","..Amy2.."},"
    --print(str1)
    str1 = "{"..Mxc..","..Myc..","..Mrd.." },"
    print(str1)
end



function showBoxC()
    str1 = "{"..Mxc..","..Myc..","..Mrd.." },"
    print(str1)
end






function fill_yellow(x,y,r,g,b,a)
  r = 200 g = 250 b = 0 a = 250
  return r,g,b,a
end
function mapPixel_fillGreen(x,y,r,g,b,a)
  r = 0 g = 200 b = 0 a = 180
  return r,g,b,a
end
function fillRed(x,y,r,g,b,a)
  r = 200 g = 0 b = 0 a = 100
  return r,g,b,a
end
local x1,y1,x2,y2,angle,angleInc,radius,radiusInc
radius = 100 radiusInc = 0.01
angle = 0 angleInc = 0.01
x1=0 y1=0 x2=0 y2=0
function g4() -- draw something
  local x,y,r,g,b,a,mx,my
  r = 255 g = 255 b = 255 a = 255
  mx=imageD:getWidth()  my=imageD:getHeight() 
  local i,k,n  k = 50
  for i=0,k do
    radius = radius + radiusInc
    angle = angle + angleInc
    xa = radius * math.cos (angle)
    ya = radius * math.sin (angle)
    x2 = mx/2 + xa  y2 = my/2 + ya
    
    imageD:setPixel(x2,y2,r,g,b,255)

  end
end
function g3() -- add some random points
    local x,y,r,g,b,xh,yh,n,j,k
    xh = imageD:getWidth()/2
    yh = imageD:getHeight()/2
    for n=0,1 do
      x = xh - 255*math.random()
      y = yh - 255*math.random()
      r = 255*math.random()
      g = 255*math.random()
      b = 255*math.random()
      for j=0,3 do
        for k=0,3 do
          imageD:setPixel(x+k,y+j,r,g,b,255)
        end
      end
    end
end






function Colorize()
  
  local x,y,w,h,maxColor,r,g,b,a,idxc,s,idxT
  
  w = imageD2base:getWidth()  h = imageD2base:getHeight()
  s = w*h
  local w1,h1
  w1 = imageD2:getWidth()  h1 = imageD2:getHeight()
  
  if(w~=w1) or h~=h1 then
    print ("mask size unmatched")
  end
  
  print("start colorizing..."..w.."x"..h) --"   "..w1.."x"..h1)
 
  maxColor = #tabColor
  
  
  buildC2tab()
  
  
  buildTabImage(C2tab) 
  
  local Max = MaxValue
  if Max < 10 then Max = 10 end
--  if Max > MAXITER then Max = MAXITER end
  
  --bmrk1
  
  for y=0,h-1 do
    for x=0,w-1 do
          r,g,b,a = imageD2base:getPixel(x,y)
          idxc = g*256 + b
          idxc = math.min(idxc,maxColor)
          
          if oneColor then
            idxT = C2tab[idxc]
            
            if(idxc > (95/100 * MAXITER)) or (idxc == 0)then 
              idxT = Media 
            end  -- draw black if near escape
              
            if idxT > Media then
              local p = 1- (3/4 + ( 1/4 * (idxT-Media) / (Max-Media)))
              if p > 1 or p < 0 then
                print("Max anomalo "..p)
                print("idxc: "..idxc.." idxT:"..idxT.."  Max:"..Max.."  Media:"..Media)
              end  
              r=Huer * p
              g=Hueg * p
              b=Hueb * p
            else
              local p = 1 - (3/4 -  ((3/4 - 1/20) * (Media-idxT) / (Media-0)))
              if p > 1 or p < 0 then
                print("Min anomalo "..p)
                print("idxc: "..idxc.." idxT:"..idxT.."  Max:"..Max.."  Media:"..Media)
              end  
              r=Huer * p
              g=Hueg * p
              b=Hueb * p
            end
          else
            r,g,b,a = gettabColor(idxc)
          end
          
          imageD2:setPixel(x,y,r,g,b,255)
    end
--    if (y%20)==0 then
--      io.write("\r"..(math.floor(1000*y/h)/10).."%")
--    end
  end
  imageG2 = gr.newImage(imageD2)
  doColorize = false
  print("stop colorizing...")
end







function controls()
  local f1,f2,f3,f4,f5,f,c,str
  gridRCk(16)
  
  local k = 16
  gr.print ("Max: "..MaxValue,10*k,7*k)
  gr.print ("Med: "..Media,15*k,7*k)
  
  
  local col,row,k
  
  
  col = 39 row = 1 k=16
  sp1 = slider(1,col*k,row*k,10*k,1*k,sp1)  Freq  = 100 * sp1 --also used as hue of hsv
  gr.print("F",(col-1)*k+8,row*k)
  
  row = row+1
  sp2 = slider(2,col*k,row*k,10*k,1*k,sp2)  StartColor = 100 * sp2 -- also used as saturation of hsv
  gr.print("I",(col-1)*k+8,row*k)
  
  
  row = row+2
  gr.print("S",(col-1)*k+8,row*k)
  sp4 = slider(4,col*k,row*k,10*k,1*k,sp4)  Luminosity = 100 * sp4 -- used as val luminosity of hsv
  if LastLum ~= Luminosity then
    Huer,Hueg,Hueb = hue2rgb(Hue)
    LastLum = Luminosity
  end
  
  row = row+1
  gr.print("V",(col-1)*k+8,row*k)
  sp5 = slider(5,col*k,row*k,10*k,1*k,sp5)  Contrast = 100 * sp5 -- used as val luminosity of hsv
  if LastCont ~= Contrast then
    Huer,Hueg,Hueb = hue2rgb(Hue)
    LastCont = Contrast
  end
  
  row = row+2
  gr.print("H",(col-1)*k+8,row*k)
  sp3 = slider(3,20*k,row*k,30*k,1*k,sp3)  Hue = 360 * sp3 -- used as val luminosity of hsv
  if LastHue ~= Hue then
    Huer,Hueg,Hueb = hue2rgb(Hue)
    LastHue = Hue
  end
  
  
  
  col = 45 row = 8 k=16  local f
  ------------------------- change freq color -----------------------------------------
  f1=checkToggle(2, row,  col) 
  f2=checkToggle(3, row,  col+1) 
  str = string.format("f:%3d",Freq) gr.print(str, (col+2)*k, row*k)
  
  if f1 then Freq = (Freq - 0.1)%100    end
  if f2 then Freq = (Freq + 0.1)%100   end
  
  sp1 = Freq/100
  if LastFreq ~= Freq then
    tr2:set('cfreq',Freq)
    tr2:set('buildCT',true)
    buildColorsTab() 
    LastFreq = Freq 
  end
  -------------------------------------------------------------------------------------
  row=row+1
  ------------------------- change start color -----------------------------------------
  f3=checkToggle(4, row,  col) 
  f4=checkToggle(5, row,  col+1) 
  str = string.format("i:%3d",StartColor) gr.print(str, (col+2)*k, row*k)
  
  if f3 then StartColor = (StartColor - 0.1)%100  end
  if f4 then StartColor = (StartColor + 0.1)%100  end
  
  sp2 = StartColor/100
  if LastStart ~= StartColor then 
    tr2:set('cstart',StartColor)
    tr2:set('buildCT',true)
    buildColorsTab() 
    LastStart = StartColor 
  end
  -------------------------------------------------------------------
  row=row+1
  ------------------------------------------------------------------- colorizing button
  f5,c=checkToggle(6, row,  col) -- colorize button
  str = string.format("colorize") gr.print(str, (col+1)*k, row*k)
  
  if f5 and c then  
    upCnt = upCnt+1
    print(upCnt)
    --tr2:set('stop',true) 
    --tr2:set('colorize', true)  
    doColorize=true
  end
  -------------------------------------------------------------------
  row=row+1
  ------------------------------------------------------------------- 
  local f6
  local lastf6
  f6 =checkToggle(7, row,  col, true) -- Mono color on-of
  if f6  then
    str = string.format("1color on") 
    oneColor=true 
  else
    str = string.format("1color of") 
    oneColor=false 
  end
  if Lastf6 ~= f6 then 
    Lastf6 = f6
    --tr2:set("oneColor",oneColor) 
    --buildColorsTab()
  end
  gr.print(str, (col+1)*k, row*k)
  local r,g,b,a  r,g,b,a = gr.getColor()
  
  gr.setColor(Huer,Hueg,Hueb,250)
  gr.rectangle("fill",col*k,(row+1)*k,3*k,1*k)
  gr.setColor(r,g,b,a)
  -------------------------------------------------------------------
end


liveM = 0
liveT1 = 0
function showLive()
  liveM = (liveM+1)%1000
  if tr2:peek('live') then liveT1 = tr2:get('live') end
  gr.print(liveM,sw-4*16,sh-3*16)
  gr.print(liveM,sw-4*16,sh-3*16)
  gr.print(liveT1,sw-4*16,sh-2*16)
end




function buildC2tab()
  print("build istogram tab")
  local r,g,b,a,v,w,h
  w=imageD2base:getWidth()
  h=imageD2base:getHeight()
  for y=0,h-1 do
    for x=0,w-1 do
      r,g,b,a = imageD2base:getPixel(x,y)
      v = g*256+b
      if(v > 0) and (v < MAXITER) then  -- don't update at 0 and  MAXITER
        C2tab[v] = C2tab[v]+1 
      end 
    end
  end
end

